﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using C1.Silverlight;

namespace C1TreeView_ExpandCollapseAll
{
    public partial class MainPage : UserControl
    {
        List<C1TreeViewItem> itemList;

        public MainPage()
        {
            InitializeComponent();

            c1TreeView1.ItemsSource = Data.LoadData();

            c1TreeView1.Loaded += new RoutedEventHandler(c1TreeView1_Loaded);
        }

        public void ExpandAll()
        {
            if (itemList == null || itemList.Count == 0)
            {
                itemList = new List<C1TreeViewItem>();
                IList<DependencyObject> items = new List<DependencyObject>();
                VTreeHelper.GetChildrenOfType(c1TreeView1, typeof(C1TreeViewItem), ref items);

                foreach (C1TreeViewItem item in items)
                {
                    ExpandNodes(item);
                }
            }
            else
            {
                foreach (C1TreeViewItem item in itemList)
                {
                    item.IsExpanded = true;
                }
            }
        }


        void c1TreeView1_Loaded(object sender, RoutedEventArgs e)
        {
            Dispatcher.BeginInvoke(() =>
                {
                    ExpandAll();
                });
        }

        public void ExpandNodes(C1TreeViewItem item)
        {
            item.IsExpanded = true;

            itemList.Add(item);

            Dispatcher.BeginInvoke(() =>
            {
                IList<DependencyObject> items = new List<DependencyObject>();
                VTreeHelper.GetChildrenOfType(item, typeof(C1TreeViewItem), ref items);

                foreach (C1TreeViewItem childItem in items)
                {
                    ExpandNodes(childItem);
                }
            });
        }

        private void btnExpand_Click(object sender, RoutedEventArgs e)
        {
            ExpandAll();
        }

        private void btnCollapse_Click(object sender, RoutedEventArgs e)
        {
            if (itemList != null)
            {
                foreach (C1TreeViewItem item in itemList)
                {
                    item.IsExpanded = false;
                }
            }
        }
    }
}
