﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.Generic;

namespace C1TreeView_ExpandCollapseAll
{
    public class Table : INotifyPropertyChanged, IEditableObject
    {

        public event PropertyChangedEventHandler PropertyChanged;

        private string _name;
        private string _previousName;
        private bool _isChecked;

        public string Name
        {
            get
            {
                return _name;
            }
            set
            {
                _name = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("Name"));
                }
            }
        }

        public bool IsChecked
        {
            get
            {
                return _isChecked;
            }
            set
            {
                _isChecked = value;
                if (PropertyChanged != null)
                {
                    PropertyChanged(this, new PropertyChangedEventArgs("IsChecked"));
                }
            }
        }

        public List<Table> Children { get; set; }

        public void BeginEdit()
        {
            _previousName = Name;
        }

        public void CancelEdit()
        {
            Name = _previousName;
        }

        public void EndEdit()
        {
            _previousName = null;
        }
    }
}
